/*
 * Copyright (C) 2002-2007  Auriga
 *
 * This file is part of Auriga.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */

#include <stdio.h>
#include <string.h>

#include "clif.h"
#include "itemdb.h"
#include "map.h"
#include "vending.h"
#include "pc.h"
#include "skill.h"
#include "battle.h"
#include "nullpo.h"
#include "chat.h"
#include "npc.h"
#include "trade.h"
#include "chrif.h"
#include "atcommand.h"
#include "unit.h"
//  ++ NPCIX by Blaze
#include <time.h>

static int vending_id = 1;
//  -- NPCIX by Blaze

//  ++ NPCIX by Blaze
/*==========================================
 * IXIDєz
 *------------------------------------------
*/
static int vending_newid(void)
{
	
	if(vending_id == 0x7fffffff) {
		printf("vending_id : ID is overflow !!\n");
		vending_id = 1;		// єz
	}

	return vending_id++;
}

//  -- NPCIX by Blaze

/*==========================================
 * IX
 *------------------------------------------
*/
void vending_closevending(struct map_session_data *sd)
{
	nullpo_retv(sd);

	sd->vender_id = 0;
	sd->vend_num  = 0; // on principle
	clif_closevendingboard(&sd->bl,-1);

	return;
}

/*==========================================
 * IXACeXgv
 *------------------------------------------
 */
void vending_vendinglistreq(struct map_session_data *sd,int id)
{
//  ++ NPCIX by Blaze
	struct block_list *vbl;

	nullpo_retv(sd);

	if((vbl = map_id2bl(id)) == NULL)
		return;
	if(vbl->prev == NULL)
		return;
	// PCNPĈݗL
	if(vbl->type != BL_PC && vbl->type != BL_NPC)
		return;
	if(sd->vender_id != 0 || sd->state.deal_mode != 0)
		return;
	if(sd->bl.m != vbl->m)
		return;
	if(unit_distance(sd->bl.x,sd->bl.y,vbl->x,vbl->y) > AREA_SIZE)
		return;

	// PCɂIX
	if(vbl->type == BL_PC) {
		struct map_session_data *vsd = (struct map_session_data *)vbl;
		if(vsd->vender_id == 0 || vsd->state.deal_mode != 0)
			return;
		sd->view_vendid = vsd->vender_id;	// Xgv̘IXIDL
		clif_vendinglist(sd, vsd);
	}
	// NPCɂIX
	else if(vbl->type == BL_NPC) {
		struct npc_data *vnd = (struct npc_data *)vbl;
		if(vnd->vender_id == 0)
			return;
		sd->view_vendid = vnd->vender_id;	// Xgv̘IXIDL
		clif_npcvendinglist(sd, vnd);
	}

	return;
//  -- NPCIX by Blaze
}

/*==========================================
 * IXACew
 *------------------------------------------
 */
void vending_purchasereq(struct map_session_data *sd, unsigned short len, int id, unsigned char *p)
{
//  ++ NPCIX by Blaze
	int i, j, w, new_, blank, vend_list[MAX_VENDING];
	double z;
	short nameid, amount, idx;
	struct block_list *vbl;
	struct map_session_data *vsd = NULL;
	struct npc_data *vnd = NULL;
	//struct vending vending[MAX_VENDING]; // against duplicate packets/items

	nullpo_retv(sd);

	vbl = map_id2bl(id);

	if (vbl == NULL)
		return;
	if (vbl->prev == NULL)
		return;
	if (sd->bl.m != vbl->m)
		return;
	if (unit_distance(sd->bl.x,sd->bl.y,vbl->x,vbl->y) > AREA_SIZE)
		return;

	vsd = BL_DOWNCAST( BL_PC, vbl );
	vnd = BL_DOWNCAST( BL_NPC, vbl );

	if (vsd == NULL && vnd == NULL)
		return;


	// PCɂIX
	if(vsd) {
		if (vsd->vender_id == 0)
			return;
		if (vsd->vender_id != sd->view_vendid)	// XgvƕύX
			return;
	}

	// NPCɂIX
	else if(vnd) {
		if (vnd->vender_id == 0)
			return;
		if (vnd->vender_id != sd->view_vendid)	// XgvƕύX
			return;
	}

	// check number of buying items
	if (len < 8 + 4 || len > 8 + 4 * MAX_VENDING) {
		clif_buyvending(sd, 0, 0x7fff, 4); // not enough quantity (index and amount are unknown)
		return;
	}

	blank = pc_inventoryblank(sd);

	// duplicate items in vending to check hacker with multiple packets
	//memcpy(&vending, &vsd->vending, sizeof(struct vending) * MAX_VENDING); // copy vending list

	// some checks
	z = 0.;
	w = 0;
	new_ = 0;
	for(i = 0; 8 + 4 * i < len; i++) {
		amount = *(short*)(p + 4 * i);
		if (amount <= 0)
			return;

		idx = *(short*)(p + 2 + 4 * i) - 2;
		// check of index
		if (idx < 0) 
			return;
		if (vsd && idx >= MAX_CART)
			return;
		if (vnd && idx >= MAX_VENDING)
			return;

		if (vsd) {
			for(j = 0; j < vsd->vend_num; j++) {
				if (vsd->vending[j].index == idx) {
					vend_list[i] = j;
					break;
				}
			}
			if (j == vsd->vend_num)
				return; // ؂

			z += ((double)vsd->vending[j].value * (double)amount);
			if (z > (double)sd->status.zeny || z < 0. || z > (double)MAX_ZENY) { // fix positiv overflow (buyer)
				clif_buyvending(sd, idx, amount, 1); // you don't have enough zenys
				return; // zenys
			}
			if (z + (double)vsd->status.zeny > (double)MAX_ZENY) { // fix positiv overflow (merchand)
				clif_buyvending(sd, idx, vsd->vending[j].amount, 4); // not enough quantity
				return; // zenys
			}
			w += itemdb_weight(nameid = vsd->status.cart[idx].nameid) * amount;
			if (w + sd->weight > sd->max_weight) {
				clif_buyvending(sd, idx, amount, 2); // you can not buy, because overweight
				return; // dʒ
			}
			// if they try to add packets (example: get twice or more 2 apples if marchand has only 3 apples).
			// here, we check cumulativ amounts
			if (vsd->vending[j].amount < amount) { // send more quantity is not a hack (an other player can have buy items just before)
				clif_buyvending(sd, idx, vsd->vending[j].amount, 4); // not enough quantity
				return;
			}
		}
		else if (vnd) {
			z += ((double)vnd->vending[idx].value * (double)amount);
			if (z > (double)sd->status.zeny || z < 0. || z > (double)MAX_ZENY) { // fix positiv overflow (buyer)
				clif_buyvending(sd, idx, amount, 1); // you don't have enough zenys
				return; // zenys
			}
			w += itemdb_weight(nameid = vnd->vending[idx].item.nameid) * amount;
			if (w + sd->weight > sd->max_weight) {
				clif_buyvending(sd, idx, amount, 2); // you can not buy, because overweight
				return; // dʒ
			}
			if (vnd->vending[idx].item.amount < amount) {
				clif_buyvending(sd, idx, vnd->vending[idx].item.amount, 4); // not enough quantity
				return;
			}
		}

		switch(pc_checkadditem(sd, nameid, amount)) {
		case ADDITEM_EXIST:
			break;
		case ADDITEM_NEW:
			new_++;
			if (new_ > blank)
				return; // ސ
			break;
		case ADDITEM_OVERAMOUNT:
			return; // ACe
		}
	}

	// [j[x
	pc_payzeny(sd, (int)z);
	if(vsd) {
		// ŋ
		if(battle_config.tax_rate)
			z = z * (100 - battle_config.tax_rate) / 100;
		// [j[󂯎
		pc_getzeny(vsd, (int)z);
	}
	// vending items
	for(i = 0; 8 + 4 * i < len; i++) {
		amount = *(short*)(p + 4 * i);
		idx = *(short*)(p + 2 + 4 * i) - 2;
		if(vsd) {
			pc_additem(sd, &vsd->status.cart[idx], amount);
			vsd->vending[vend_list[i]].amount -= amount;
			pc_cart_delitem(vsd, idx, amount, 0);
			clif_vendingreport(vsd, idx, amount);
			if (battle_config.buyer_name) {
				char output[128];
				snprintf(output, sizeof(output), msg_txt(148), sd->status.name);
				clif_disp_onlyself(vsd->fd, output);
			}
		}
		else if(vnd) {
			struct item item_tmp;
			memcpy(&item_tmp,&vnd->vending[idx].item,sizeof(item_tmp));

			// tACe
			if(item_tmp.limit > 0) {
				item_tmp.limit = (unsigned int)time(NULL) + item_tmp.limit;
			}
			pc_additem(sd, &item_tmp, amount);

			vnd->vending[idx].item.amount -= amount;
			// ACeȂȂ̂ŃACe폜
			if(vnd->vending[idx].item.amount <= 0) {
				memset(&vnd->vending[idx],0,sizeof(vnd->vending[0]));
				vnd->vend_num--;
			}
		}
	}
	sd->view_vendid = 0;	// ĂIXID

	// save both players to avoid crash: they always have no advantage/disadvantage between the 2 players
	chrif_save(sd,0);
	if(vsd)
		chrif_save(vsd,0);

	if(vnd) {
		// iꂽƂACxgs
		if(vnd->shop_event[0]) {
			npc_event_do(vnd->shop_event);
		}
		// ̂ŘIX
		if(vnd->vend_num <= 0) {
			vending_closenpcvending(vnd);
		}
	}

	return;
//  -- NPCIX by Blaze
}

/*==========================================
 * IXJ
 *------------------------------------------
 */
void vending_openvending(struct map_session_data *sd, int len, char *shop_title, unsigned char flag, unsigned char *p)
{
	int i, vending_skill_lvl;

	nullpo_retv(sd);

	// has vender ability to open a shop?
	vending_skill_lvl = pc_checkskill(sd, MC_VENDING);
	if (vending_skill_lvl < 1 || !pc_iscarton(sd)) {
		clif_skill_fail(sd, MC_VENDING, 0, 0);
		return;
	}

	// player must close its actual shop before
	if (sd->vender_id != 0)
		return;

	// normal client can not send 'void' shop title
	if (shop_title[0] == '\0')
		return;

	if (sd->state.deal_mode != 0)
		return;

	if (sd->npc_id)
		npc_event_dequeue(sd);
	if (sd->trade_partner)
		trade_tradecancel(sd);
	if (sd->chatID)
		chat_leavechat(sd, 0);

	// normal client send NULL -> force it (against hacker)
	shop_title[79] = '\0';

	if (flag) {
		len -= 85;
		// check if at least 1 item, and not more than possible
		if (len < 8 || len > 8 * MAX_VENDING || len > 8 * (2 + vending_skill_lvl)) {
			clif_skill_fail(sd, MC_VENDING, 0, 0);
			return;
		}

		memset(&sd->vending[0], 0, sizeof(struct vending) * MAX_VENDING);

		// check if items are valid
		for(i = 0; (8 * i) < len; i++) {
			short idx, amount;
			idx = *(short*)(p + 8 * i) - 2;
			amount = *(short*)(p + 2 + 8 * i);
			if (idx < 0 || idx >= MAX_CART || amount <= 0) {
				memset(&sd->vending[0], 0, sizeof(struct vending) * MAX_VENDING);
				clif_skill_fail(sd, MC_VENDING, 0, 0);
				return;
			}

			sd->vending[i].index  = idx;
			sd->vending[i].amount = amount;
			sd->vending[i].value  = *(int*)(p + 4 + 8 * i);

			// J[g̃ACeƔ̔ACeɑႪ璆~
			// łɁ|l̒li|ľ`FbNĂ܂
			if (pc_cartitem_amount(sd, idx, amount) < 0) {
				memset(&sd->vending[0], 0, sizeof(struct vending) * MAX_VENDING);
				clif_skill_fail(sd, MC_VENDING, 0, 0);
				return;
			}

			if (sd->vending[i].value > battle_config.vending_max_value) {
				sd->vending[i].value = battle_config.vending_max_value;
			} else if (sd->vending[i].value < 0) { // hack
				memset(&sd->vending[0], 0, sizeof(struct vending) * MAX_VENDING);
				clif_skill_fail(sd, MC_VENDING, 0, 0);
				return;
			}
		}

		// shop can be opened
		unit_stop_walking(&sd->bl, 1);
		unit_stopattack(&sd->bl);

//  ++ NPCIX by Blaze
		sd->vender_id = vending_newid();	// IXIDєz
//  -- NPCIX by Blaze
		sd->vend_num  = i;
		memset(sd->message, 0, sizeof(sd->message));
		strncpy(sd->message, shop_title, 80);
		if (clif_openvending(sd) > 0) {
			clif_showvendingboard(&sd->bl, shop_title, -1);
		} else {
			sd->vender_id = 0;
			sd->vend_num = 0; // on principle
		}
	}

	return;
}

//  ++ NPCIX by Blaze
/*==========================================
 * NPCIXݒ
 *------------------------------------------
*/
int vending_setnpcvending(struct npc_data *nd, struct npc_vending* vend_data, int idx)
{
	nullpo_retr(1, nd);
	nullpo_retr(1, vend_data);

	// IXJ݂ĂƂ͏i֎~
	//if (nd->vender_id != 0)
	//	return 1;

	if(!itemdb_exists(vend_data->item.nameid))
		return 1;

	if(vend_data->item.amount <= 0)
		return 1;

	if (vend_data->value > battle_config.vending_max_value)
		vend_data->value = battle_config.vending_max_value;

	if(vend_data->value < 0)
		return 1;

	// idx0w肳ꂽ󂫃CfbNX
	if(idx == 0) {
		for(idx = 0; idx < MAX_VENDING; idx++) {
			if(nd->vending[idx].item.amount <= 0) {
				break;
			}
		}
	} else {
		idx -= 1;
	}

	if(idx < 0 || idx >= MAX_VENDING)
		return 1;

	memcpy(&nd->vending[idx], vend_data, sizeof(nd->vending[0]));

	// IXJݒ͏iɕύXߘIXIDVK擾
	if(nd->vender_id != 0) {
		nd->vender_id = vending_newid();
	}

	return 0;
}

/*==========================================
 * NPCIX폜
 *------------------------------------------
*/
int vending_delnpcvending(struct npc_data *nd, int idx)
{
	nullpo_retr(1, nd);

	// IXJ݂ĂƂ͏i֎~
	//if (nd->vender_id != 0)
	//	return 1;

	// idx0w肳ꂽSẴXg
	if(idx == 0) {
		memset(nd->vending, 0, sizeof(nd->vending));
		return 0;
	}

	idx -= 1;
	if(idx < 0 || idx > MAX_VENDING)
		return 1;

	memset(&nd->vending[idx], 0, sizeof(nd->vending[0]));

	// IXJݒ̏
	if(nd->vender_id != 0) {
		int i,cnt = 0;

		// i𐔂Ȃ
		for(i = 0; i < MAX_VENDING; i++) {
			if(nd->vending[i].item.amount > 0) {
				cnt++;
			}
		}

		if(cnt > 0) {
			nd->vend_num = cnt;
			// iɕύXߘIXIDVK擾
			nd->vender_id = vending_newid();
		}
		else {	// iSĂȂȂ
			vending_closenpcvending(nd);
		}
	}

	return 0;
}

/*==========================================
 * NPCIXJ
 *------------------------------------------
 */
int vending_opennpcvending(struct npc_data *nd, char *shop_title, const char *event)
{
	int i, count = 0;

	nullpo_retr(1, nd);

	// ɘIXJ݂ĂƂ͎s
	if (nd->vender_id != 0)
		return 1;

	// ^Cg̃`FbN
	if (shop_title[0] == '\0')
		return 1;

	shop_title[79] = '\0';

	for(i = 0; i < MAX_VENDING; i++) {
		if(nd->vending[i].item.amount <= 0)
			continue;
		if (nd->vending[i].value > battle_config.vending_max_value)
			nd->vending[i].value = battle_config.vending_max_value;
		else if (nd->vending[i].value < 0) 
			return 1;
		count++;
	}

	if(count <= 0)
		return 1;

	nd->vend_num = count;
	nd->vender_id = vending_newid();	// IXIDєz
	memset(nd->shop_title, 0, sizeof(nd->shop_title));
	strncpy(nd->shop_title, shop_title, 80);
	memcpy(nd->shop_event,event,sizeof(nd->shop_event));
	nd->shop_event[sizeof(nd->shop_event)-1] = '\0';

	clif_showvendingboard(&nd->bl, shop_title, -1);

	return 0;
}

/*==========================================
 * NPCIX
 *------------------------------------------
*/
int vending_closenpcvending(struct npc_data *nd)
{
	nullpo_retr(1, nd);

	nd->vender_id = 0;
	nd->vend_num = 0;
	memset(nd->shop_title, 0, sizeof(nd->shop_title));
	memset(nd->shop_event, 0, sizeof(nd->shop_event));

	clif_closevendingboard(&nd->bl,-1);

	return 0;
}
//  -- NPCIX by Blaze
